.proc DecodeLevelData ; A=map number
  asl
  pha
  asl
  asl
  asl
  tay
  lda LevelAttributes+0,y
  sta EnemiesPool+0
  lda LevelAttributes+1,y
  sta EnemiesPool+1
  lda LevelAttributes+2,y
  sta EnemiesPool+2
  lda LevelAttributes+3,y
  sta EnemiesPool+3
  lda LevelAttributes+4,y
  sta LevelSpinShootSpeed
  lda LevelAttributes+5,y
  sta LevelSpinShootChance
  lda LevelAttributes+6,y
  sta LevelSpinShootRate
  pla
  tay
  lda LevelMapData+0,y
  sta 7
  lda LevelMapData+1,y
  sta 8
CorrectMap:

; clear out level chunks and level metatiles
  ldx #0
  txa
: sta LevelBuf,x
  inx
  bne :-

  tax
: sta LevelDataBuf,x
  inx
  cpx #12
  bne :-

; read information from map
  iny
  lda LevelMapData,y
  unpack LevelDataPoints+0, LevelDataPoints+1
  iny
  lda LevelMapData,y
  unpack LevelDataPoints+2, LevelDataPoints+3
  iny

  lda LevelDataPoints+0
  and #%0011
  asl ; *2
  asl ; *4
  asl ; *8
  asl ; *16
  asl ; *32
  asl ; *64
  add #32-16
  sta PlayerPXH

  lda LevelDataPoints+0
  and #%1100 ; *4
  asl ; *8
  asl ; *16
  add #32+(32-16)
  sta PlayerPYH

  ldx #0
  ldy #2
FillDataBuf:
  lda (7),y
  sta LevelDataBuf,x
  iny
  inx
  cpx #12
  bne FillDataBuf
.endproc
; don't put anything here
.proc LevelChunks2LevelBuf
ChunkNum = 0
TileLo = 1
TileHi = 2
NeedFlip = 3
LevelBufIndex = 4
LevelChunk = 5
; transfer 4x4 tiles to 16x16
  lda #0
  sta ChunkNum
ChunkLoop:
  lda ChunkNum
  jsr MakeLevelBufIndexFromChunk
  stx LevelBufIndex

  ldy ChunkNum
  lda LevelDataBuf,y
  sta LevelChunk
  and #%111111
  asl
  asl
  asl
  tay
ChunkRow:
  sty TempVal
  lda RandomLevelParts,y
  unpack TileHi, TileLo
  ldy TileLo
  lda MetaNybbleTable,y
  sta LevelBuf+0,x
  ldy TileHi
  lda MetaNybbleTable,y
  sta LevelBuf+1,x
  ldy TempVal
  lda RandomLevelParts+1,y
  unpack TileHi, TileLo
  ldy TileLo
  lda MetaNybbleTable,y
  sta LevelBuf+2,x
  ldy TileHi
  lda MetaNybbleTable,y
  sta LevelBuf+3,x

  lda LevelChunk
  and #LC_H
  beq :+
    lda LevelBuf+0,x
    pha
    lda LevelBuf+3,x
    sta LevelBuf+0,x
    pla
    sta LevelBuf+3,x

    lda LevelBuf+1,x
    pha
    lda LevelBuf+2,x
    sta LevelBuf+1,x
    pla
    sta LevelBuf+2,x
  :

  txa
  axs #-16
  txa
  sub #32
  and #%110000
  beq ChunkRowExit
  ldy TempVal
  iny
  iny
  jmp ChunkRow
ChunkRowExit:

  lda LevelChunk
  and #LC_V
  beq NoVertFlip
    ldy #4
    ldx LevelBufIndex
  : lda LevelBuf+(16*0),x
    pha
    lda LevelBuf+(16*3),x
    sta LevelBuf+(16*0),x
    pla
    sta LevelBuf+(16*3),x

    lda LevelBuf+(16*1),x
    pha
    lda LevelBuf+(16*2),x
    sta LevelBuf+(16*1),x
    pla
    sta LevelBuf+(16*2),x
    inx
    dey
    bne :-
NoVertFlip:

  inc ChunkNum
  lda ChunkNum
  cmp #12
  jne ChunkLoop    

JustFinishLevel:
  rts

MakeLevelBufIndexFromChunk:
  pha
  ; make vertical offset
  and #%1100
  asl
  asl
  asl
  asl
  add #16*2
  sta TempVal
  ; make horizontal
  pla
  and #%11
  asl
  asl
  add TempVal
  tax
  rts
.endproc

.proc LevelMapData
  .addr Map1
  .addr Map2
  .addr Map3
  .addr Map4
  .addr Map5
  .addr Map6
  .addr Map7
  .addr Map8
  .addr Map9
  .addr Map10

Map1:
  .byt $01,$00
  .byt LC_EMPTY, LC_EMPTY, LC_AMMO_SQUARE, LC_EMPTY
  .byt LC_EMPTY, LC_SMALL_CORNER, LC_H|LC_CORNER_PLAIN, LC_EMPTY
  .byt LC_CORNER_PLAIN, LC_HORIZ_TUNNEL_BREAK, LC_HORIZ_SOLID_LINE
Map2:
  .byt $01,$00
  .byt LC_EMPTY, LC_SMALL_CORNER, LC_PLATFORM, LC_EMPTY
  .byt LC_EMPTY, LC_CORNER_PLAIN, LC_SMALL_CORNER, LC_H|LC_V|LC_CORNER_PLAIN
  .byt LC_EMPTY, LC_AMMO_SQUARE, LC_EMPTY, LC_H|LC_CORNER_PLAIN
Map3:
  .byt $01,$00
  .byt LC_EMPTY, LC_AMMO_SQUARE, LC_EMPTY, LC_EMPTY
  .byt LC_H|LC_VERT_SOLID_LINE, LC_RIGHT_TRIANGLE, LC_H|LC_CORNER_BREAKABLE, LC_EMPTY
  .byt LC_EMPTY, LC_HORIZ_SOLID_LINE, LC_AMMO_SQUARE, LC_EMPTY
Map4:
  .byt $01,$00
  .byt LC_EMPTY, LC_EMPTY, LC_V|LC_CORNER_PLAIN, LC_EMPTY
  .byt LC_H|LC_V|LC_SMALL_CORNER, LC_RIGHT_TRIANGLE, LC_AMMO_SQUARE, LC_VERT_SOLID_LINE
  .byt LC_EMPTY, LC_V|LC_RIGHT_TRIANGLE, LC_H|LC_RIGHT_TRIANGLE, LC_VERT_SOLID_LINE
Map5:
  .byt $05,$00
  .byt LC_EMPTY, LC_EMPTY, LC_EMPTY, LC_H|LC_CORNER_PLAIN
  .byt LC_H|LC_VERT_SOLID_LINE, LC_SMALL_CORNER, LC_H|LC_CORNER_PLAIN, LC_V|LC_CORNER_PLAIN
  .byt LC_EMPTY, LC_EMPTY, LC_AMMO_SQUARE, LC_EMPTY
Map6:
  .byt $02,$00
  .byt LC_EMPTY, LC_V|LC_HORIZ_SOLID_LINE, LC_EMPTY, LC_EMPTY
  .byt LC_VERT_SOLID_LINE, LC_V|LC_CORNER_AMMO, LC_V|LC_H|LC_CORNER_AMMO, LC_EMPTY
  .byt LC_CORNER_PLAIN, LC_H|LC_CORNER_BREAKABLE, LC_AMMO_SQUARE, LC_EMPTY
Map7:
  .byt $01,$00
  .byt LC_EMPTY, LC_EMPTY, LC_H|LC_VERT_SOLID_LINE, LC_EMPTY
  .byt LC_V|LC_H|LC_SMALL_CORNER, LC_HORIZ_SOLID_LINE, LC_H|LC_CORNER_PLAIN, LC_V|LC_HORIZ_SOLID_LINE
  .byt LC_CORNER_PLAIN, LC_SMALL_CORNER, LC_AMMO_SQUARE, LC_EMPTY
Map8:
  .byt $02,$00
  .byt LC_EMPTY, LC_V|LC_HORIZ_SOLID_LINE, LC_AMMO_SQUARE, LC_EMPTY
  .byt LC_V|LC_H|LC_RIGHT_TRIANGLE, LC_HORIZ_SOLID_LINE, LC_H|LC_CORNER_PLAIN, LC_HORIZ_SOLID_LINE
  .byt LC_EMPTY, LC_EMPTY, LC_H|LC_V|LC_SMALL_CORNER, LC_V|LC_SMALL_CORNER
Map9:
  .byt $01,$00
  .byt LC_V|LC_CORNER_PLAIN, LC_AMMO_SQUARE, LC_EMPTY, LC_EMPTY
  .byt LC_V|LC_SMALL_CORNER, LC_RIGHT_TRIANGLE, LC_AMMO_SQUARE, LC_EMPTY
  .byt LC_EMPTY, LC_V|LC_H|LC_RIGHT_TRIANGLE, LC_CORNER_BREAKABLE, LC_EMPTY
Map10:
  .byt $01,$00
  .byt LC_EMPTY, LC_EMPTY, LC_H|LC_SMALL_CORNER, LC_EMPTY
  .byt LC_MIDDLE_4BLOCKS, LC_H|LC_SMALL_CORNER, LC_H|LC_CORNER_PLAIN, LC_EMPTY
  .byt LC_EMPTY, LC_V|LC_H|LC_SMALL_CORNER, LC_V|LC_SMALL_CORNER, LC_EMPTY

;
  .byt 12-1,$00,$00
  .byt LC_V+LC_RIGHT_TRIANGLE,LC_MIDDLE_4BLOCKS,LC_MIDDLE_4BLOCKS,LC_V+LC_H+LC_RIGHT_TRIANGLE
  .byt LC_MIDDLE_4BLOCKS,LC_EMPTY, LC_EMPTY,LC_MIDDLE_4BLOCKS
  .byt LC_RIGHT_TRIANGLE,LC_MIDDLE_4BLOCKS,LC_MIDDLE_4BLOCKS,LC_H+LC_RIGHT_TRIANGLE
.endproc

.proc LevelAttributes
; enemy 1, enemy 2, enemy 3, enemy 4
; LevelSpinShootSpeed
; LevelSpinShootChance
; LevelSpinShootRate
; 1
  .byt AOBJECT_SPINNER, AOBJECT_SPINNER, AOBJECT_SPINNER, AOBJECT_SPINNER
  .byt 8, %111, %111, 0, 0, 0, 0, 0, 0, 0, 0, 0
; 2
  .byt AOBJECT_BURGER1, AOBJECT_BURGER1, AOBJECT_SPINNER, AOBJECT_SPINNER
  .byt 8, %111, %111, 0, 0, 0, 0, 0, 0, 0, 0, 0
; 3
  .byt AOBJECT_CANNON1, AOBJECT_SPINNER, AOBJECT_MINE, AOBJECT_MINE
  .byt 10, %111, %111, 0, 0, 0, 0, 0, 0, 0, 0, 0
; 4
  .byt AOBJECT_SPINNER, AOBJECT_SPINNER, AOBJECT_SPINNER, AOBJECT_SPINNER
  .byt 15, %111, %111, 0, 0, 0, 0, 0, 0, 0, 0, 0
; 5
  .byt AOBJECT_SPINNER, AOBJECT_SPINNER, AOBJECT_SPINNER, AOBJECT_SPINNER
  .byt 8, %111, %111, 0, 0, 0, 0, 0, 0, 0, 0, 0
; 6
  .byt AOBJECT_SPINNER, AOBJECT_SPINNER, AOBJECT_SPINNER, AOBJECT_SPINNER
  .byt 8, %111, %111, 0, 0, 0, 0, 0, 0, 0, 0, 0
; 7
  .byt AOBJECT_SPINNER, AOBJECT_SPINNER, AOBJECT_SPINNER, AOBJECT_SPINNER
  .byt 8, %111, %111, 0, 0, 0, 0, 0, 0, 0, 0, 0
; 8
  .byt AOBJECT_SPINNER, AOBJECT_SPINNER, AOBJECT_SPINNER, AOBJECT_SPINNER
  .byt 8, %111, %111, 0, 0, 0, 0, 0, 0, 0, 0, 0
; 9
  .byt AOBJECT_SPINNER, AOBJECT_SPINNER, AOBJECT_SPINNER, AOBJECT_SPINNER
  .byt 8, %111, %111, 0, 0, 0, 0, 0, 0, 0, 0, 0
; 10
  .byt AOBJECT_SPINNER, AOBJECT_SPINNER, AOBJECT_SPINNER, AOBJECT_SPINNER
  .byt 8, %111, %111, 0, 0, 0, 0, 0, 0, 0, 0, 0
.endproc

.enum
  LC_EMPTY
  LC_MIDDLE_4BLOCKS
  LC_VERT_TUNNEL_BREAK
  LC_HORIZ_TUNNEL_BREAK
  LC_CORNER_BREAK
  LC_PLATFORM
  LC_PLATFORM_GAP
  LC_RIGHT_TRIANGLE
  LC_CORNER_BREAKABLE
  LC_CORNER_AMMO
  LC_CORNER_PLAIN
  LC_VERT_SOLID_LINE
  LC_HORIZ_SOLID_LINE
  LC_SOLID_FULL
  LC_AMMO_SQUARE
  LC_VERT_BREAK_LINE
  LC_HORIZ_BREAK_LINE
  LC_SMALL_CORNER
  LC_SPACE_8 = -1
  LC_SPACE_7 = -2
  LC_SPACE_6 = -3
  LC_SPACE_5 = -4
  LC_SPACE_4 = -5
  LC_SPACE_3 = -6
  LC_SPACE_2 = -7
  LC_SPACE_1 = -8
.endenum
LC_H = %01000000
LC_V = %10000000

; ---How chunks correspond to LevelBuf blocks:--- 
; ................
; ................
; 0000111122223333
; 0000111122223333
; 0000111122223333
; 0000111122223333
; 4444555566667777
; 4444555566667777
; 4444555566667777
; 4444555566667777
; 88889999aaaabbbb
; 88889999aaaabbbb
; 88889999aaaabbbb
; 88889999aaaabbbb
; ................

MetaNybbleTable:
  .byt METATILE_EMPTY, METATILE_SOLID, METATILE_BREAKABLE, METATILE_MINE, METATILE_PLATFORM, METATILE_GRASSY, METATILE_AMMO

.enum
  NYB_EMPTY
  NYB_SOLID
  NYB_BREAK
  NYB_MINE
  NYB_PLATF
  NYB_GRASS
  NYB_AMMO
.endenum

.proc RandomLevelParts
; 0 EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
; 1 MIDDLE_4BLOCKS
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_SOLID,(NYB_SOLID<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_SOLID,(NYB_SOLID<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
; 2 VERT_TUNNEL_BREAK
  .byt (NYB_SOLID<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_SOLID
  .byt (NYB_SOLID<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_BREAK
  .byt (NYB_SOLID<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_BREAK
  .byt (NYB_SOLID<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_SOLID
; 3 HORIZ_TUNNEL_BREAK
  .byt (NYB_SOLID<<4)+NYB_BREAK,(NYB_BREAK<<4)+NYB_SOLID
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_SOLID<<4)+NYB_SOLID,(NYB_SOLID<<4)+NYB_SOLID
; 4 CORNER_BREAK
  .byt (NYB_EMPTY<<4)+NYB_SOLID,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_SOLID,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_BREAK<<4)+NYB_BREAK,(NYB_SOLID<<4)+NYB_SOLID
  .byt (NYB_BREAK<<4)+NYB_BREAK,(NYB_EMPTY<<4)+NYB_EMPTY
; 5 PLATFORM
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_PLATF<<4)+NYB_PLATF,(NYB_PLATF<<4)+NYB_PLATF
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
; 6 PLATFORM_GAP
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_AMMO, (NYB_AMMO<<4) +NYB_EMPTY
  .byt (NYB_PLATF<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_PLATF
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
; 7 RIGHT_TRIANGLE
  .byt (NYB_SOLID<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_SOLID<<4)+NYB_SOLID,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_SOLID<<4)+NYB_SOLID,(NYB_SOLID<<4)+NYB_EMPTY
  .byt (NYB_SOLID<<4)+NYB_SOLID,(NYB_SOLID<<4)+NYB_SOLID
; 8 CORNER_BREAKABLE
  .byt (NYB_SOLID<<4)+NYB_EMPTY,(NYB_BREAK<<4)+NYB_BREAK
  .byt (NYB_SOLID<<4)+NYB_EMPTY,(NYB_BREAK<<4)+NYB_BREAK
  .byt (NYB_SOLID<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_SOLID<<4)+NYB_SOLID,(NYB_SOLID<<4)+NYB_SOLID
; 9 CORNER_AMMO
  .byt (NYB_SOLID<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_SOLID<<4)+NYB_EMPTY,(NYB_AMMO<<4) +NYB_EMPTY
  .byt (NYB_SOLID<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_SOLID<<4)+NYB_SOLID,(NYB_SOLID<<4)+NYB_SOLID
; 10 CORNER_PLAIN
  .byt (NYB_SOLID<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_SOLID<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_SOLID<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_SOLID<<4)+NYB_SOLID,(NYB_SOLID<<4)+NYB_SOLID
; 11 VERT_SOLID_LINE
  .byt (NYB_SOLID<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_SOLID<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_SOLID<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_SOLID<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
; 12 HORIZ_SOLID_LINE
  .byt (NYB_SOLID<<4)+NYB_SOLID,(NYB_SOLID<<4)+NYB_SOLID
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
; 13 SOLID_FULL
  .byt (NYB_SOLID<<4)+NYB_SOLID,(NYB_SOLID<<4)+NYB_SOLID
  .byt (NYB_SOLID<<4)+NYB_SOLID,(NYB_SOLID<<4)+NYB_SOLID
  .byt (NYB_SOLID<<4)+NYB_SOLID,(NYB_SOLID<<4)+NYB_SOLID
  .byt (NYB_SOLID<<4)+NYB_SOLID,(NYB_SOLID<<4)+NYB_SOLID
; 14 AMMO_SQUARE
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_AMMO, (NYB_AMMO <<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_AMMO, (NYB_AMMO <<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
; 15 VERT_BREAK_LINE
  .byt (NYB_BREAK<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_BREAK<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_BREAK<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_BREAK<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
; 16 HORIZ_BREAK_LINE
  .byt (NYB_BREAK<<4)+NYB_BREAK,(NYB_BREAK<<4)+NYB_BREAK
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
; 17 SMALL_CORNER
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_AMMO <<4)+NYB_EMPTY
  .byt (NYB_SOLID<<4)+NYB_AMMO, (NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_SOLID<<4)+NYB_SOLID,(NYB_EMPTY<<4)+NYB_EMPTY
; 18
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
; 19
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
; 20
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
; 21
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
; 22
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
; 23
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
; 24
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
  .byt (NYB_EMPTY<<4)+NYB_EMPTY,(NYB_EMPTY<<4)+NYB_EMPTY
.endproc

; level instructions---------------------------------------------------------
.enum
  LVI_END_LEVEL
  LVI_MAP_CHANGE   ; nn(map number to switch to. bit 7=flip vert, 6=flip horiz)
  LVI_WAIT_UNTIL   ; (.....nab) no enemies, wave A end, wave B end

  LVI_ENEMY_WAVE   ; tt(type) ... $00
  LVI_ENEMY_ASAP   ; tt(type) ... $00

.endenum

;
;
;
;
;

